<?xml version="1.0" encoding="UTF-8"?>

<configuration>

  <!-- Property definitions -->
  <property name="ErrorContext" value="%X{cid}" scope="context" />
  <property name="TraceCacheSupport" value="true" scope="context"/>

  <!--     Appender definitions -->  
  <appender name="R" class="ch.qos.logback.core.rolling.RollingFileAppender">
    <!--See also http://logback.qos.ch/manual/appenders.html#RollingFileAppender-->
    <filter class="ch.qos.logback.core.filter.EvaluatorFilter">
      <evaluator> <!-- defaults to type ch.qos.logback.classic.boolex.JaninoEventEvaluator -->
        <expression> if(mdc.get("ErrorContext") != null &amp;&amp;
                        (event.getLevel().levelInt &lt; Level.ERROR.levelInt || event.getLevel() == Level.OFF))
                        return true;
                    return false;
        </expression>
      </evaluator>
      <OnMismatch>ACCEPT</OnMismatch>
      <OnMatch>DENY</OnMatch>
    </filter> 
    <File>${sdweb.home}/logs/sdweb.log</File>
    <encoder>
      <charset>UTF-8</charset>
      <pattern>%.-1level %X{ErrorContext} %X{instanceinfo} %property{HOSTNAME} %X{sessionid} %X{documentid} %d{yyyy-MM-dd HH:mm:ss.SSS} [%t] %c - %m%n</pattern>
    </encoder>
    <rollingPolicy class="ch.qos.logback.core.rolling.FixedWindowRollingPolicy">
      <maxIndex>10</maxIndex>
      <FileNamePattern>${sdweb.home}/logs/sdweb.log.%i</FileNamePattern>
    </rollingPolicy>
    <triggeringPolicy class="ch.qos.logback.core.rolling.SizeBasedTriggeringPolicy">
      <MaxFileSize>10000KB</MaxFileSize>
    </triggeringPolicy>
  </appender>
  
  <appender name="E" class="ch.qos.logback.classic.sift.SiftingAppender">
    <filter class="ch.qos.logback.core.filter.EvaluatorFilter">
	  <evaluator> <!-- defaults to type ch.qos.logback.classic.boolex.JaninoEventEvaluator -->
		<expression>return (((String) mdc.get("ErrorContext")) != null);</expression>
	  </evaluator>
	  <OnMismatch>DENY</OnMismatch>
	  <OnMatch>NEUTRAL</OnMatch>
	</filter>
	<discriminator>
	  <key>ErrorContext</key>
	  <defaultValue>unknown</defaultValue>
	</discriminator>
	<sift>
	  <appender name="${ErrorContext}" class="ch.qos.logback.core.FileAppender">
		<file>${sdweb.home}/logs/error/${ErrorContext}.log</file>
		<append>true</append>
		<encoder class="ch.qos.logback.classic.encoder.PatternLayoutEncoder">
		  <pattern>%-5p %X{instanceinfo} %property{HOSTNAME} %X{sessionid} %X{documentid} %d{yyyy-MM-dd HH:mm:ss.SSS} %-4r [%t] %c - %m%n</pattern>
		  <ImmediateFlush>true</ImmediateFlush>
		</encoder>
		</appender>
	</sift>
  </appender>
  
  <appender name="P" class="ch.qos.logback.core.rolling.RollingFileAppender">
    <!--See also http://logback.qos.ch/manual/appenders.html#RollingFileAppender-->
    <File>${sdweb.home}/logs/Performance.log</File>
    <encoder>
      <charset>UTF-8</charset>
      <pattern>%-5p %X{instanceinfo} %property{HOSTNAME} %X{sessionid} %X{documentid} %d{yyyy-MM-dd HH:mm:ss.SSS} [%t] %c - %m%n</pattern>
    </encoder>
    <rollingPolicy class="ch.qos.logback.core.rolling.FixedWindowRollingPolicy">
      <maxIndex>10</maxIndex>
      <FileNamePattern>${sdweb.home}/logs/Performance.log.%i</FileNamePattern>
    </rollingPolicy>
    <triggeringPolicy class="ch.qos.logback.core.rolling.SizeBasedTriggeringPolicy">
      <MaxFileSize>10000KB</MaxFileSize>
    </triggeringPolicy>
  </appender>

  <appender name="S" class="ch.qos.logback.core.rolling.RollingFileAppender">
    <!--See also http://logback.qos.ch/manual/appenders.html#RollingFileAppender-->
    <File>${sdweb.home}/logs/Statistic.log</File>
    <encoder>
      <charset>UTF-8</charset>
      <pattern>%X{instanceinfo} %property{HOSTNAME} %d{yyyy-MM-dd HH:mm:ss.SSS} - %m%n</pattern>
    </encoder>
    <rollingPolicy class="ch.qos.logback.core.rolling.FixedWindowRollingPolicy">
      <maxIndex>10</maxIndex>
      <FileNamePattern>${sdweb.home}/logs/Performance.log.%i</FileNamePattern>
    </rollingPolicy>
    <triggeringPolicy class="ch.qos.logback.core.rolling.SizeBasedTriggeringPolicy">
      <MaxFileSize>10000KB</MaxFileSize>
    </triggeringPolicy>
  </appender>


  <appender name="STDOUT" class="ch.qos.logback.core.ConsoleAppender">
    <encoder>
      <pattern>%-5p %X{instanceinfo} %property{HOSTNAME} %X{sessionid} %X{documentid} %d{yyyy-MM-dd HH:mm:ss.SSS} [%t] %c - %m%n</pattern>
    </encoder>
  </appender>
  
  <!--     Turbofilter definitions -->  	 
  <turboFilter class="de.softpro.logging.XTurboFilter">
	<Logger>@TCACHE@</Logger>
	<Exclude>true</Exclude>
	<DiagClass>data</DiagClass>
  </turboFilter>  	

  <turboFilter class="de.softpro.logging.XTurboFilter">
	<Logger>de.softpro.sdweb.PerformanceLog</Logger>
	<MsgId>SDW0053</MsgId>
  </turboFilter>
    
  <!-- messages that should be logged always -->
  <turboFilter class="de.softpro.logging.XTurboFilter">
	<Logger>de.softpro</Logger>
	<MsgId>SDW0068</MsgId>
  </turboFilter>
    
  <!-- GWT Client log. Should stay on debug -->
  <logger name="de.softpro.sdweb.gwt.server.log.SDWebClientXjLog" level="DEBUG"/>
    
  <!--     Logger definitions -->  
  <logger name="org.codehaus.groovy" level="ERROR"/>
  
  <logger name="de.softpro.sdweb.plugins.impl" level="ERROR"/>
  <logger name="de.softpro.sdweb.bootstrap" level="INFO"/>
  <logger name="de.softpro.sdweb.services" level="ERROR"/>
  <logger name="de.softpro.sdweb.j2ee.DocIdFilterRequestWrapper" level="INFO" />
  <logger name="de.softpro.sdweb.XjLogJHelper" level="INFO"/>
  <logger name="de.softpro.sdweb.PerformanceLog" level="ERROR">
	<appender-ref ref="P"/>
  </logger>  
  <logger name="de.softpro.sdweb.statistic.StatisticLogger" level="INFO">
	<appender-ref ref="S"/>
  </logger>

  <logger name="sails" level="ERROR"/>
  <logger name="sails.app.controllers" level="ERROR"/>
  <logger name="de.softpro" level="ERROR"/>
  <logger name="de.softpro.sdweb.j2ee" level="ERROR"/>
  <logger name="de.softpro.sdweb.j2ee.TraceCacheFilter" level="ERROR"/>
	
  <root level="ERROR">
	<appender-ref ref="R"/>
	<appender-ref ref="E"/>
  </root>
  
</configuration>